// DeadLockTest1.cpp : Defines the entry point for the console application.
//


#include "stdafx.h"
#include "stddef.h"
#include <stdio.h>
#include <process.h>
#include <windows.h>


CRITICAL_SECTION cs1;
CRITICAL_SECTION cs2;

//This is a potential deadlock, only standard version can catch
//If you add 'Sleeps', deadlock does happen, basic version can also catch

unsigned __stdcall  ThreadProc1(void *param)
{
  EnterCriticalSection(&cs1);
  //Sleep(2000);
  EnterCriticalSection(&cs2);

  LeaveCriticalSection(&cs2);
  LeaveCriticalSection(&cs1);

  return 0;
}

unsigned __stdcall  ThreadProc2(void *param)
{
  EnterCriticalSection(&cs2);
  //Sleep(2000);
  EnterCriticalSection(&cs1);

  LeaveCriticalSection(&cs1);
  LeaveCriticalSection(&cs2);

  return 0;
}


int main(int argc, char* argv[])
{

   InitializeCriticalSection(&cs1);
   InitializeCriticalSection(&cs2);
   

  
   HANDLE handle1 = (HANDLE) _beginthreadex(NULL, 0, ThreadProc1, NULL, 0, NULL);
   HANDLE handle2 = (HANDLE) _beginthreadex(NULL, 0, ThreadProc2, NULL, 0, NULL);

   WaitForSingleObject(handle1,INFINITE);
   return 0;
}
